<?php 

class Elementor_Codeneric_UAM_Extension {



	private static $_instance = null;

    public function __construct() {       
        add_action( 'plugins_loaded', [ $this, 'init' ] );

    }
    public function init() {
		// Check if Elementor installed and activated
		if (did_action( 'elementor/loaded' ) ) {
			add_action( 'elementor/widgets/widgets_registered', [ $this, 'init_widgets' ] );
			add_action( 'elementor/elements/categories_registered',[ $this, 'add_elementor_widget_categories' ]);
		

		}

	}
	public function add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'codeneric-uam',
			[
				'title' => __( 'Ultimate Ads Manager', 'plugin-name' ),
				'icon' => 'fa fa-plug',
			]
		);
	
	
	}
    public function init_widgets() {

		// Include Widget files
		require_once( dirname(__FILE__). '/elementor-widget.php' );

		// Register widget
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor_Codeneric_Widget() );

	}
	public function includes() {}
	public static function instance() {

		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;

	}


	public function update_place($data) {
		$place_id =  Ultimate_Ads_Manager_Place::update_by_elementor_widget_id($data["widget_id"], $data["title"], $data["width"], $data["height"]); 
		return '[uam_place id="'.$place_id.'"]'; 
	}

}
Elementor_Codeneric_UAM_Extension::instance();