<?php


class Ultimate_Ads_Manager_Legacy {
    private static function handle_outdated_premium_2_2_4(){
        $config = $GLOBALS["cc_uam_config"];

    if(!function_exists('codeneric_uam_legacy_checkForUpdates')){
        function codeneric_uam_legacy_checkForUpdates($value){
            $uam_premium_key = 'ultimate-ads-manager-premium/ultimate-ads-manager-premium.php';

            $cache = get_transient('cc_uam_cache_codeneric_uam_legacy_checkForUpdates');
            if($cache !== false){
                $value->response[ $uam_premium_key ] = $cache;
                return $value;
            }

            $config = $GLOBALS["cc_uam_config"];
            $is_premium_plugin = true;
            include ABSPATH . WPINC . '/version.php';

            $update_url = $config['wpps_url'].'/premium/'.$config['plugin_slug_abbr'];
            $update_url = str_replace('https://', 'http://', $update_url);
            $plugin_id = get_option('codeneric_uam_uuid');
            $options = array(
                'timeout'    => ( ( defined('DOING_CRON') && DOING_CRON ) ? 30 : 10 ),
                'user-agent' => 'WordPress/' . get_bloginfo('version') . '; ' . get_bloginfo( 'url' ),
                'body'       => array(
                    'version' => '2.2.4',
                    'plugin_id' => $plugin_id
                )
            );
            //check if server wants to give us the premium plugin
            $raw_response = wp_remote_post( $update_url, $options );

            if ( is_wp_error( $raw_response ) ){ //error, maybe server is down
                return $value;
            }

            $status_code = wp_remote_retrieve_response_code( $raw_response );

            if(402 === $status_code){
                if(!function_exists('cc_uam_admin_notice_expired')){
                    function cc_uam_admin_notice_expired() {
                        $class = "update-nag";
                        $message = 'Your Ultimate Ads Manager premium status is expired!';
                        echo"<div class=\"$class\"> <p>$message</p></div>";
                    }
                    add_action( 'admin_notices', 'cc_uam_admin_notice_expired' );
                }

            }


            if ( 200 != $status_code ) { //server seems to be down, apache responded //TODO: handle buyer-under-reserve
                return $value;
            }
            try{
                $response = json_decode( wp_remote_retrieve_body( $raw_response ) ); //we are premium baby!
                if ( empty( $response ) )
                    return $value;
            }catch (Exception $e){
                print_r($e);
                return $value;
            }


            //there is a new premium plugin and we don't have it yet... UPDATE!

            $temp_test = new stdClass();
            $temp_test->id = $response->id;
            $temp_test->slug = $response->slug;
            $temp_test->new_version = $response->new_version;
            $temp_test->url = $response->url;
            $temp_test->package = $response->package;

            $temp_test->plugin = $uam_premium_key;
            

            $value->response[ $uam_premium_key ] = $temp_test; //show this now
            set_transient('cc_uam_cache_codeneric_uam_legacy_checkForUpdates', $temp_test, 60); 
            return $value;
        }
 
        add_filter( 'site_transient_update_plugins', 'codeneric_uam_legacy_checkForUpdates' , 10, 1 );
    }

    $cooldown_transient = get_transient('cc_uam_cooldown_codeneric_uam_legacy_checkForUpdates');
    if($cooldown_transient === 'too early'){ 
        return;
    }
    set_transient('cc_uam_cooldown_codeneric_uam_legacy_checkForUpdates', 'too early', 60);  

    global $wp_version;
    if (version_compare( $wp_version, '4.6.0', '>=' )) {
      require_once(
        ABSPATH.'wp-admin/includes/class-wp-upgrader.php'
      ); //for plugins_api..
    } else {
      require_once(
        ABSPATH.'wp-admin/includes/plugin-install.php'
      ); //for plugins_api..
    }
    require_once ($config['premium_plugin_root_path'].'/admin/partials/empty-wp-update-skin.php'); 

    $upgrader = new \Plugin_Upgrader(new \Ultimate_Ads_Manager_Premium_Installer_Upgrader_Skins());

    
    
    $uam_premium_key = 'ultimate-ads-manager-premium/ultimate-ads-manager-premium.php';
    $suc = $upgrader->upgrade($uam_premium_key); //this calls indirectly checkForUpdates
    if($suc === true){
        $prem_data = get_plugin_data($config['premium_plugin_root_path'].'/ultimate-ads-manager-premium.php'); 
        $prem_version = $prem_data['Version'];
        if(version_compare($prem_version, '2.2.4', '>')){
            \activate_plugin($uam_premium_key); 
        }

    }else{
        if(!function_exists('cc_uam_admin_notice_outdated_premium')){
            function cc_uam_admin_notice_outdated_premium() {
                $class = "update-nag";
                $message = 'Your Ultimate Ads Manager premium exptension is outdated! Please update it.';
                echo"<div class=\"$class\"> <p>$message</p></div>";
            }
            add_action( 'admin_notices', 'cc_uam_admin_notice_outdated_premium' );
        }
    }


    }

    public static function handle(){
        $config = $GLOBALS["cc_uam_config"];
        if(version_compare($config['premium_version'], '2.2.4', '==' )){
            self::handle_outdated_premium_2_2_4();
        }
    }

}